Ruby: pm_block_node Struct Reference

Ruby 3.4.5p51 (2025-07-16 revision 20cda200d3ce092571d0b5d342dadca69636cb0f)

Data Fields
pm_block_node Struct Reference

BlockNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
pm_constant_id_list_t | locals
| BlockNode#locals.
struct pm_node * | parameters
| BlockNode#parameters.
struct pm_node * | body
| BlockNode#body.
pm_location_t | opening_loc
| BlockNode#opening_loc.
pm_location_t | closing_loc
| BlockNode#closing_loc.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

BlockNode.

Represents a block of ruby code.

    [1, 2, 3].each { |i| puts x }
                   ^^^^^^^^^^^^^^

Type: PM_BLOCK_NODE

Definition at line 1762 of file ast.h.

## Field Documentation

## ◆ base

pm_node_t pm_block_node::base

The embedded base node.

Definition at line 1764 of file ast.h.

Referenced by pm_dump_json().

## ◆ body

struct pm_node* pm_block_node::body

BlockNode#body.

The body of the block.

    [1, 2, 3].each { |i| puts x }
                         ^^^^^^

Definition at line 1799 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ closing_loc

pm_location_t pm_block_node::closing_loc

BlockNode#closing_loc.

Represents the location of the closing |.

    [1, 2, 3].each { |i| puts x }
                       ^

Definition at line 1819 of file ast.h.

Referenced by pm_dump_json().

## ◆ locals

pm_constant_id_list_t pm_block_node::locals

BlockNode#locals.

The local variables declared in the block.

    [1, 2, 3].each { |i| puts x } # locals: [:i]
                      ^

Definition at line 1775 of file ast.h.

Referenced by pm_dump_json(), and pm_node_destroy().

## ◆ opening_loc

pm_location_t pm_block_node::opening_loc

BlockNode#opening_loc.

Represents the location of the opening |.

    [1, 2, 3].each { |i| puts x }
                     ^

Definition at line 1809 of file ast.h.

Referenced by pm_dump_json().

## ◆ parameters

struct pm_node* pm_block_node::parameters

BlockNode#parameters.

The parameters of the block.

    [1, 2, 3].each { |i| puts x }
                     ^^^
    [1, 2, 3].each { puts _1 }
                   ^^^^^^^^^^^
    [1, 2, 3].each { puts it }
                   ^^^^^^^^^^^

Definition at line 1789 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

The documentation for this struct was generated from the following file:

- prism/ast.h